// Copyright (c) 2008 The Board of Trustees of The Leland Stanford Junior University
// Copyright (c) 2011, 2012 Open Networking Foundation
// Copyright (c) 2012, 2013 Big Switch Networks, Inc.
// This library was generated by the LoxiGen Compiler.
// See the file LICENSE.txt which should have been included in the source distribution

// Automatically generated by LOXI from template const_serializer.java
// Do not modify

package org.projectfloodlight.openflow.protocol.ver14;

import org.projectfloodlight.openflow.protocol.*;
import org.projectfloodlight.openflow.protocol.action.*;
import org.projectfloodlight.openflow.protocol.actionid.*;
import org.projectfloodlight.openflow.protocol.bsntlv.*;
import org.projectfloodlight.openflow.protocol.errormsg.*;
import org.projectfloodlight.openflow.protocol.meterband.*;
import org.projectfloodlight.openflow.protocol.instruction.*;
import org.projectfloodlight.openflow.protocol.instructionid.*;
import org.projectfloodlight.openflow.protocol.match.*;
import org.projectfloodlight.openflow.protocol.oxm.*;
import org.projectfloodlight.openflow.protocol.queueprop.*;
import org.projectfloodlight.openflow.types.*;
import org.projectfloodlight.openflow.util.*;
import org.projectfloodlight.openflow.exceptions.*;
import org.projectfloodlight.openflow.protocol.OFBadPropertyCode;
import io.netty.buffer.ByteBuf;
import com.google.common.hash.PrimitiveSink;

public class OFBadPropertyCodeSerializerVer14 {

    public final static short BAD_TYPE_VAL = (short) 0x0;
    public final static short BAD_LEN_VAL = (short) 0x1;
    public final static short BAD_VALUE_VAL = (short) 0x2;
    public final static short TOO_MANY_VAL = (short) 0x3;
    public final static short DUP_TYPE_VAL = (short) 0x4;
    public final static short BAD_EXPERIMENTER_VAL = (short) 0x5;
    public final static short BAD_EXP_TYPE_VAL = (short) 0x6;
    public final static short BAD_EXP_VALUE_VAL = (short) 0x7;
    public final static short EPERM_VAL = (short) 0x8;

    public static OFBadPropertyCode readFrom(ByteBuf bb) throws OFParseError {
        try {
            return ofWireValue(bb.readShort());
        } catch (IllegalArgumentException e) {
            throw new OFParseError(e);
        }
    }

    public static void writeTo(ByteBuf bb, OFBadPropertyCode e) {
        bb.writeShort(toWireValue(e));
    }

    public static void putTo(OFBadPropertyCode e, PrimitiveSink sink) {
        sink.putShort(toWireValue(e));
    }

    public static OFBadPropertyCode ofWireValue(short val) {
        switch(val) {
            case BAD_TYPE_VAL:
                return OFBadPropertyCode.BAD_TYPE;
            case BAD_LEN_VAL:
                return OFBadPropertyCode.BAD_LEN;
            case BAD_VALUE_VAL:
                return OFBadPropertyCode.BAD_VALUE;
            case TOO_MANY_VAL:
                return OFBadPropertyCode.TOO_MANY;
            case DUP_TYPE_VAL:
                return OFBadPropertyCode.DUP_TYPE;
            case BAD_EXPERIMENTER_VAL:
                return OFBadPropertyCode.BAD_EXPERIMENTER;
            case BAD_EXP_TYPE_VAL:
                return OFBadPropertyCode.BAD_EXP_TYPE;
            case BAD_EXP_VALUE_VAL:
                return OFBadPropertyCode.BAD_EXP_VALUE;
            case EPERM_VAL:
                return OFBadPropertyCode.EPERM;
            default:
                throw new IllegalArgumentException("Illegal wire value for type OFBadPropertyCode in version 1.4: " + val);
        }
    }


    public static short toWireValue(OFBadPropertyCode e) {
        switch(e) {
            case BAD_TYPE:
                return BAD_TYPE_VAL;
            case BAD_LEN:
                return BAD_LEN_VAL;
            case BAD_VALUE:
                return BAD_VALUE_VAL;
            case TOO_MANY:
                return TOO_MANY_VAL;
            case DUP_TYPE:
                return DUP_TYPE_VAL;
            case BAD_EXPERIMENTER:
                return BAD_EXPERIMENTER_VAL;
            case BAD_EXP_TYPE:
                return BAD_EXP_TYPE_VAL;
            case BAD_EXP_VALUE:
                return BAD_EXP_VALUE_VAL;
            case EPERM:
                return EPERM_VAL;
            default:
                throw new IllegalArgumentException("Illegal enum value for type OFBadPropertyCode in version 1.4: " + e);
        }
    }

}
