// Copyright (c) 2008 The Board of Trustees of The Leland Stanford Junior University
// Copyright (c) 2011, 2012 Open Networking Foundation
// Copyright (c) 2012, 2013 Big Switch Networks, Inc.
// This library was generated by the LoxiGen Compiler.
// See the file LICENSE.txt which should have been included in the source distribution

// Automatically generated by LOXI from template const_set_serializer.java
// Do not modify

package org.projectfloodlight.openflow.protocol.ver14;

import org.projectfloodlight.openflow.protocol.*;
import org.projectfloodlight.openflow.protocol.action.*;
import org.projectfloodlight.openflow.protocol.actionid.*;
import org.projectfloodlight.openflow.protocol.bsntlv.*;
import org.projectfloodlight.openflow.protocol.errormsg.*;
import org.projectfloodlight.openflow.protocol.meterband.*;
import org.projectfloodlight.openflow.protocol.instruction.*;
import org.projectfloodlight.openflow.protocol.instructionid.*;
import org.projectfloodlight.openflow.protocol.match.*;
import org.projectfloodlight.openflow.protocol.oxm.*;
import org.projectfloodlight.openflow.protocol.queueprop.*;
import org.projectfloodlight.openflow.types.*;
import org.projectfloodlight.openflow.util.*;
import org.projectfloodlight.openflow.exceptions.*;
import org.projectfloodlight.openflow.protocol.OFBsnLacpState;
import java.util.Set;
import io.netty.buffer.ByteBuf;
import com.google.common.hash.PrimitiveSink;
import java.util.EnumSet;
import java.util.Collections;


public class OFBsnLacpStateSerializerVer14 {

    public final static byte BSN_LACP_STATE_ACTIVITY_VAL = (byte) 0x1;
    public final static byte BSN_LACP_STATE_TIMEOUT_VAL = (byte) 0x2;
    public final static byte BSN_LACP_STATE_AGGREGATION_VAL = (byte) 0x4;
    public final static byte BSN_LACP_STATE_SYNCHRONIZATION_VAL = (byte) 0x8;
    public final static byte BSN_LACP_STATE_COLLECTING_VAL = (byte) 0x10;
    public final static byte BSN_LACP_STATE_DISTRIBUTING_VAL = (byte) 0x20;
    public final static byte BSN_LACP_STATE_DEFAULTED_VAL = (byte) 0x40;
    public final static byte BSN_LACP_STATE_EXPIRED_VAL = (byte) 0x80;

    public static Set<OFBsnLacpState> readFrom(ByteBuf bb) throws OFParseError {
        try {
            return ofWireValue(bb.readByte());
        } catch (IllegalArgumentException e) {
            throw new OFParseError(e);
        }
    }

    public static void writeTo(ByteBuf bb, Set<OFBsnLacpState> set) {
        bb.writeByte(toWireValue(set));
    }

    public static void putTo(Set<OFBsnLacpState> set, PrimitiveSink sink) {
        sink.putByte(toWireValue(set));
    }


    public static Set<OFBsnLacpState> ofWireValue(byte val) {
        EnumSet<OFBsnLacpState> set = EnumSet.noneOf(OFBsnLacpState.class);

        if((val & BSN_LACP_STATE_ACTIVITY_VAL) != 0)
            set.add(OFBsnLacpState.BSN_LACP_STATE_ACTIVITY);
        if((val & BSN_LACP_STATE_TIMEOUT_VAL) != 0)
            set.add(OFBsnLacpState.BSN_LACP_STATE_TIMEOUT);
        if((val & BSN_LACP_STATE_AGGREGATION_VAL) != 0)
            set.add(OFBsnLacpState.BSN_LACP_STATE_AGGREGATION);
        if((val & BSN_LACP_STATE_SYNCHRONIZATION_VAL) != 0)
            set.add(OFBsnLacpState.BSN_LACP_STATE_SYNCHRONIZATION);
        if((val & BSN_LACP_STATE_COLLECTING_VAL) != 0)
            set.add(OFBsnLacpState.BSN_LACP_STATE_COLLECTING);
        if((val & BSN_LACP_STATE_DISTRIBUTING_VAL) != 0)
            set.add(OFBsnLacpState.BSN_LACP_STATE_DISTRIBUTING);
        if((val & BSN_LACP_STATE_DEFAULTED_VAL) != 0)
            set.add(OFBsnLacpState.BSN_LACP_STATE_DEFAULTED);
        if((val & BSN_LACP_STATE_EXPIRED_VAL) != 0)
            set.add(OFBsnLacpState.BSN_LACP_STATE_EXPIRED);
        return Collections.unmodifiableSet(set);
    }

    public static byte toWireValue(Set<OFBsnLacpState> set) {
        byte wireValue = 0;

        for(OFBsnLacpState e: set) {
            switch(e) {
                case BSN_LACP_STATE_ACTIVITY:
                    wireValue |= BSN_LACP_STATE_ACTIVITY_VAL;
                    break;
                case BSN_LACP_STATE_TIMEOUT:
                    wireValue |= BSN_LACP_STATE_TIMEOUT_VAL;
                    break;
                case BSN_LACP_STATE_AGGREGATION:
                    wireValue |= BSN_LACP_STATE_AGGREGATION_VAL;
                    break;
                case BSN_LACP_STATE_SYNCHRONIZATION:
                    wireValue |= BSN_LACP_STATE_SYNCHRONIZATION_VAL;
                    break;
                case BSN_LACP_STATE_COLLECTING:
                    wireValue |= BSN_LACP_STATE_COLLECTING_VAL;
                    break;
                case BSN_LACP_STATE_DISTRIBUTING:
                    wireValue |= BSN_LACP_STATE_DISTRIBUTING_VAL;
                    break;
                case BSN_LACP_STATE_DEFAULTED:
                    wireValue |= BSN_LACP_STATE_DEFAULTED_VAL;
                    break;
                case BSN_LACP_STATE_EXPIRED:
                    wireValue |= BSN_LACP_STATE_EXPIRED_VAL;
                    break;
                default:
                    throw new IllegalArgumentException("Illegal enum value for type OFBsnLacpState in version 1.4: " + e);
            }
        }
        return wireValue;
    }

}
