// Copyright (c) 2008 The Board of Trustees of The Leland Stanford Junior University
// Copyright (c) 2011, 2012 Open Networking Foundation
// Copyright (c) 2012, 2013 Big Switch Networks, Inc.
// This library was generated by the LoxiGen Compiler.
// See the file LICENSE.txt which should have been included in the source distribution

// Automatically generated by LOXI from template of_factory_class.java
// Do not modify

package org.projectfloodlight.openflow.protocol.ver14;

import org.projectfloodlight.openflow.protocol.*;
import org.projectfloodlight.openflow.protocol.action.*;
import org.projectfloodlight.openflow.protocol.actionid.*;
import org.projectfloodlight.openflow.protocol.bsntlv.*;
import org.projectfloodlight.openflow.protocol.errormsg.*;
import org.projectfloodlight.openflow.protocol.meterband.*;
import org.projectfloodlight.openflow.protocol.instruction.*;
import org.projectfloodlight.openflow.protocol.instructionid.*;
import org.projectfloodlight.openflow.protocol.match.*;
import org.projectfloodlight.openflow.protocol.oxm.*;
import org.projectfloodlight.openflow.protocol.queueprop.*;
import org.projectfloodlight.openflow.types.*;
import org.projectfloodlight.openflow.util.*;
import org.projectfloodlight.openflow.exceptions.*;
import java.util.Set;
import java.util.List;
import org.projectfloodlight.openflow.protocol.OFOxmList;


public class OFFactoryVer14 implements OFFactory {
    public final static OFFactoryVer14 INSTANCE = new OFFactoryVer14();

    private final XidGenerator xidGenerator = XidGenerators.global();

    public OFActions actions() {
        return OFActionsVer14.INSTANCE;
    }
    public OFInstructions instructions() {
        return OFInstructionsVer14.INSTANCE;
    }
    public OFMeterBands meterBands() {
        return OFMeterBandsVer14.INSTANCE;
    }
    public OFOxms oxms() {
        return OFOxmsVer14.INSTANCE;
    }
    public OFQueueProps queueProps() {
        return OFQueuePropsVer14.INSTANCE;
    }
    public OFErrorMsgs errorMsgs() {
        return OFErrorMsgsVer14.INSTANCE;
    }
    public OFActionIds actionIds() {
        return OFActionIdsVer14.INSTANCE;
    }
    public OFInstructionIds instructionIds() {
        return OFInstructionIdsVer14.INSTANCE;
    }
    public OFBsnTlvs bsnTlvs() {
        return OFBsnTlvsVer14.INSTANCE;
    }


    public OFAggregateStatsReply.Builder buildAggregateStatsReply() {
        return new OFAggregateStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFAggregateStatsRequest.Builder buildAggregateStatsRequest() {
        return new OFAggregateStatsRequestVer14.Builder().setXid(nextXid());
    }

    public OFBarrierReply.Builder buildBarrierReply() {
        return new OFBarrierReplyVer14.Builder().setXid(nextXid());
    }
    public OFBarrierReply barrierReply() {
        return new OFBarrierReplyVer14(
                nextXid()
                    );
    }

    public OFBarrierRequest.Builder buildBarrierRequest() {
        return new OFBarrierRequestVer14.Builder().setXid(nextXid());
    }
    public OFBarrierRequest barrierRequest() {
        return new OFBarrierRequestVer14(
                nextXid()
                    );
    }

    public OFBsnBwClearDataReply.Builder buildBsnBwClearDataReply() {
        return new OFBsnBwClearDataReplyVer14.Builder().setXid(nextXid());
    }
    public OFBsnBwClearDataReply bsnBwClearDataReply(long status) {
        return new OFBsnBwClearDataReplyVer14(
                nextXid(),
                      status
                    );
    }

    public OFBsnBwClearDataRequest.Builder buildBsnBwClearDataRequest() {
        return new OFBsnBwClearDataRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnBwClearDataRequest bsnBwClearDataRequest() {
        return new OFBsnBwClearDataRequestVer14(
                nextXid()
                    );
    }

    public OFBsnBwEnableGetReply.Builder buildBsnBwEnableGetReply() {
        return new OFBsnBwEnableGetReplyVer14.Builder().setXid(nextXid());
    }
    public OFBsnBwEnableGetReply bsnBwEnableGetReply(long enabled) {
        return new OFBsnBwEnableGetReplyVer14(
                nextXid(),
                      enabled
                    );
    }

    public OFBsnBwEnableGetRequest.Builder buildBsnBwEnableGetRequest() {
        return new OFBsnBwEnableGetRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnBwEnableGetRequest bsnBwEnableGetRequest() {
        return new OFBsnBwEnableGetRequestVer14(
                nextXid()
                    );
    }

    public OFBsnBwEnableSetReply.Builder buildBsnBwEnableSetReply() {
        return new OFBsnBwEnableSetReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnBwEnableSetRequest.Builder buildBsnBwEnableSetRequest() {
        return new OFBsnBwEnableSetRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnBwEnableSetRequest bsnBwEnableSetRequest(long enable) {
        return new OFBsnBwEnableSetRequestVer14(
                nextXid(),
                      enable
                    );
    }

    public OFBsnGetInterfacesReply.Builder buildBsnGetInterfacesReply() {
        return new OFBsnGetInterfacesReplyVer14.Builder().setXid(nextXid());
    }
    public OFBsnGetInterfacesReply bsnGetInterfacesReply(List<OFBsnInterface> interfaces) {
        return new OFBsnGetInterfacesReplyVer14(
                nextXid(),
                      interfaces
                    );
    }

    public OFBsnGetInterfacesRequest.Builder buildBsnGetInterfacesRequest() {
        return new OFBsnGetInterfacesRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnGetInterfacesRequest bsnGetInterfacesRequest() {
        return new OFBsnGetInterfacesRequestVer14(
                nextXid()
                    );
    }

    public OFBsnGetIpMaskReply.Builder buildBsnGetIpMaskReply() {
        throw new UnsupportedOperationException("OFBsnGetIpMaskReply not supported in version 1.4");
    }

    public OFBsnGetIpMaskRequest.Builder buildBsnGetIpMaskRequest() {
        throw new UnsupportedOperationException("OFBsnGetIpMaskRequest not supported in version 1.4");
    }
    public OFBsnGetIpMaskRequest bsnGetIpMaskRequest(short index) {
        throw new UnsupportedOperationException("OFBsnGetIpMaskRequest not supported in version 1.4");
    }

    public OFBsnGetL2TableReply.Builder buildBsnGetL2TableReply() {
        throw new UnsupportedOperationException("OFBsnGetL2TableReply not supported in version 1.4");
    }

    public OFBsnGetL2TableRequest.Builder buildBsnGetL2TableRequest() {
        throw new UnsupportedOperationException("OFBsnGetL2TableRequest not supported in version 1.4");
    }
    public OFBsnGetL2TableRequest bsnGetL2TableRequest() {
        throw new UnsupportedOperationException("OFBsnGetL2TableRequest not supported in version 1.4");
    }

    public OFBsnGetMirroringReply.Builder buildBsnGetMirroringReply() {
        return new OFBsnGetMirroringReplyVer14.Builder().setXid(nextXid());
    }
    public OFBsnGetMirroringReply bsnGetMirroringReply(short reportMirrorPorts) {
        return new OFBsnGetMirroringReplyVer14(
                nextXid(),
                      reportMirrorPorts
                    );
    }

    public OFBsnGetMirroringRequest.Builder buildBsnGetMirroringRequest() {
        return new OFBsnGetMirroringRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnGetMirroringRequest bsnGetMirroringRequest(short reportMirrorPorts) {
        return new OFBsnGetMirroringRequestVer14(
                nextXid(),
                      reportMirrorPorts
                    );
    }

    public OFBsnHybridGetReply.Builder buildBsnHybridGetReply() {
        throw new UnsupportedOperationException("OFBsnHybridGetReply not supported in version 1.4");
    }

    public OFBsnHybridGetRequest.Builder buildBsnHybridGetRequest() {
        throw new UnsupportedOperationException("OFBsnHybridGetRequest not supported in version 1.4");
    }
    public OFBsnHybridGetRequest bsnHybridGetRequest() {
        throw new UnsupportedOperationException("OFBsnHybridGetRequest not supported in version 1.4");
    }

    public OFBsnInterface.Builder buildBsnInterface() {
        return new OFBsnInterfaceVer14.Builder();
    }

    public OFBsnPduRxReply.Builder buildBsnPduRxReply() {
        return new OFBsnPduRxReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnPduRxRequest.Builder buildBsnPduRxRequest() {
        return new OFBsnPduRxRequestVer14.Builder().setXid(nextXid());
    }

    public OFBsnPduRxTimeout.Builder buildBsnPduRxTimeout() {
        return new OFBsnPduRxTimeoutVer14.Builder().setXid(nextXid());
    }

    public OFBsnPduTxReply.Builder buildBsnPduTxReply() {
        return new OFBsnPduTxReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnPduTxRequest.Builder buildBsnPduTxRequest() {
        return new OFBsnPduTxRequestVer14.Builder().setXid(nextXid());
    }

    public OFBsnSetIpMask.Builder buildBsnSetIpMask() {
        throw new UnsupportedOperationException("OFBsnSetIpMask not supported in version 1.4");
    }

    public OFBsnSetL2TableReply.Builder buildBsnSetL2TableReply() {
        throw new UnsupportedOperationException("OFBsnSetL2TableReply not supported in version 1.4");
    }

    public OFBsnSetL2TableRequest.Builder buildBsnSetL2TableRequest() {
        throw new UnsupportedOperationException("OFBsnSetL2TableRequest not supported in version 1.4");
    }

    public OFBsnSetMirroring.Builder buildBsnSetMirroring() {
        return new OFBsnSetMirroringVer14.Builder().setXid(nextXid());
    }
    public OFBsnSetMirroring bsnSetMirroring(short reportMirrorPorts) {
        return new OFBsnSetMirroringVer14(
                nextXid(),
                      reportMirrorPorts
                    );
    }

    public OFBsnSetPktinSuppressionReply.Builder buildBsnSetPktinSuppressionReply() {
        return new OFBsnSetPktinSuppressionReplyVer14.Builder().setXid(nextXid());
    }
    public OFBsnSetPktinSuppressionReply bsnSetPktinSuppressionReply(long status) {
        return new OFBsnSetPktinSuppressionReplyVer14(
                nextXid(),
                      status
                    );
    }

    public OFBsnSetPktinSuppressionRequest.Builder buildBsnSetPktinSuppressionRequest() {
        return new OFBsnSetPktinSuppressionRequestVer14.Builder().setXid(nextXid());
    }

    public OFBsnShellCommand.Builder buildBsnShellCommand() {
        throw new UnsupportedOperationException("OFBsnShellCommand not supported in version 1.4");
    }

    public OFBsnShellOutput.Builder buildBsnShellOutput() {
        throw new UnsupportedOperationException("OFBsnShellOutput not supported in version 1.4");
    }
    public OFBsnShellOutput bsnShellOutput(byte[] data) {
        throw new UnsupportedOperationException("OFBsnShellOutput not supported in version 1.4");
    }

    public OFBsnShellStatus.Builder buildBsnShellStatus() {
        throw new UnsupportedOperationException("OFBsnShellStatus not supported in version 1.4");
    }
    public OFBsnShellStatus bsnShellStatus(long status) {
        throw new UnsupportedOperationException("OFBsnShellStatus not supported in version 1.4");
    }

    public OFBsnVirtualPortCreateReply.Builder buildBsnVirtualPortCreateReply() {
        return new OFBsnVirtualPortCreateReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnVirtualPortCreateRequest.Builder buildBsnVirtualPortCreateRequest() {
        return new OFBsnVirtualPortCreateRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnVirtualPortCreateRequest bsnVirtualPortCreateRequest(OFBsnVport vport) {
        return new OFBsnVirtualPortCreateRequestVer14(
                nextXid(),
                      vport
                    );
    }

    public OFBsnVirtualPortRemoveReply.Builder buildBsnVirtualPortRemoveReply() {
        return new OFBsnVirtualPortRemoveReplyVer14.Builder().setXid(nextXid());
    }
    public OFBsnVirtualPortRemoveReply bsnVirtualPortRemoveReply(long status) {
        return new OFBsnVirtualPortRemoveReplyVer14(
                nextXid(),
                      status
                    );
    }

    public OFBsnVirtualPortRemoveRequest.Builder buildBsnVirtualPortRemoveRequest() {
        return new OFBsnVirtualPortRemoveRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnVirtualPortRemoveRequest bsnVirtualPortRemoveRequest(long vportNo) {
        return new OFBsnVirtualPortRemoveRequestVer14(
                nextXid(),
                      vportNo
                    );
    }

    public OFBsnVportL2Gre.Builder buildBsnVportL2Gre() {
        return new OFBsnVportL2GreVer14.Builder();
    }

    public OFBsnVportQInQ.Builder buildBsnVportQInQ() {
        return new OFBsnVportQInQVer14.Builder();
    }

    public OFDescStatsReply.Builder buildDescStatsReply() {
        return new OFDescStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFDescStatsRequest.Builder buildDescStatsRequest() {
        return new OFDescStatsRequestVer14.Builder().setXid(nextXid());
    }
    public OFDescStatsRequest descStatsRequest(Set<OFStatsRequestFlags> flags) {
        return new OFDescStatsRequestVer14(
                nextXid(),
                      flags
                    );
    }

    public OFEchoReply.Builder buildEchoReply() {
        return new OFEchoReplyVer14.Builder().setXid(nextXid());
    }
    public OFEchoReply echoReply(byte[] data) {
        return new OFEchoReplyVer14(
                nextXid(),
                      data
                    );
    }

    public OFEchoRequest.Builder buildEchoRequest() {
        return new OFEchoRequestVer14.Builder().setXid(nextXid());
    }
    public OFEchoRequest echoRequest(byte[] data) {
        return new OFEchoRequestVer14(
                nextXid(),
                      data
                    );
    }

    public OFFeaturesReply.Builder buildFeaturesReply() {
        return new OFFeaturesReplyVer14.Builder().setXid(nextXid());
    }

    public OFFeaturesRequest.Builder buildFeaturesRequest() {
        return new OFFeaturesRequestVer14.Builder().setXid(nextXid());
    }
    public OFFeaturesRequest featuresRequest() {
        return new OFFeaturesRequestVer14(
                nextXid()
                    );
    }

    public OFFlowAdd.Builder buildFlowAdd() {
        return new OFFlowAddVer14.Builder().setXid(nextXid());
    }

    public OFFlowDelete.Builder buildFlowDelete() {
        return new OFFlowDeleteVer14.Builder().setXid(nextXid());
    }

    public OFFlowDeleteStrict.Builder buildFlowDeleteStrict() {
        return new OFFlowDeleteStrictVer14.Builder().setXid(nextXid());
    }

    public OFFlowModify.Builder buildFlowModify() {
        return new OFFlowModifyVer14.Builder().setXid(nextXid());
    }

    public OFFlowModifyStrict.Builder buildFlowModifyStrict() {
        return new OFFlowModifyStrictVer14.Builder().setXid(nextXid());
    }

    public OFFlowRemoved.Builder buildFlowRemoved() {
        return new OFFlowRemovedVer14.Builder().setXid(nextXid());
    }

    public OFFlowStatsEntry.Builder buildFlowStatsEntry() {
        return new OFFlowStatsEntryVer14.Builder();
    }

    public OFFlowStatsReply.Builder buildFlowStatsReply() {
        return new OFFlowStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFFlowStatsRequest.Builder buildFlowStatsRequest() {
        return new OFFlowStatsRequestVer14.Builder().setXid(nextXid());
    }

    public OFGetConfigReply.Builder buildGetConfigReply() {
        return new OFGetConfigReplyVer14.Builder().setXid(nextXid());
    }

    public OFGetConfigRequest.Builder buildGetConfigRequest() {
        return new OFGetConfigRequestVer14.Builder().setXid(nextXid());
    }
    public OFGetConfigRequest getConfigRequest() {
        return new OFGetConfigRequestVer14(
                nextXid()
                    );
    }

    public OFHello.Builder buildHello() {
        return new OFHelloVer14.Builder().setXid(nextXid());
    }
    public OFHello hello(List<OFHelloElem> elements) {
        return new OFHelloVer14(
                nextXid(),
                      elements
                    );
    }

    public OFMatchV1.Builder buildMatchV1() {
        throw new UnsupportedOperationException("OFMatchV1 not supported in version 1.4");
    }

    public OFNiciraControllerRoleReply.Builder buildNiciraControllerRoleReply() {
        throw new UnsupportedOperationException("OFNiciraControllerRoleReply not supported in version 1.4");
    }
    public OFNiciraControllerRoleReply niciraControllerRoleReply(OFNiciraControllerRole role) {
        throw new UnsupportedOperationException("OFNiciraControllerRoleReply not supported in version 1.4");
    }

    public OFNiciraControllerRoleRequest.Builder buildNiciraControllerRoleRequest() {
        throw new UnsupportedOperationException("OFNiciraControllerRoleRequest not supported in version 1.4");
    }
    public OFNiciraControllerRoleRequest niciraControllerRoleRequest(OFNiciraControllerRole role) {
        throw new UnsupportedOperationException("OFNiciraControllerRoleRequest not supported in version 1.4");
    }

    public OFPacketIn.Builder buildPacketIn() {
        return new OFPacketInVer14.Builder().setXid(nextXid());
    }

    public OFPacketOut.Builder buildPacketOut() {
        return new OFPacketOutVer14.Builder().setXid(nextXid());
    }

    public OFPacketQueue.Builder buildPacketQueue() {
        return new OFPacketQueueVer14.Builder();
    }

    public OFPortDesc.Builder buildPortDesc() {
        return new OFPortDescVer14.Builder();
    }

    public OFPortMod.Builder buildPortMod() {
        return new OFPortModVer14.Builder().setXid(nextXid());
    }

    public OFPortStatsEntry.Builder buildPortStatsEntry() {
        return new OFPortStatsEntryVer14.Builder();
    }

    public OFPortStatsReply.Builder buildPortStatsReply() {
        return new OFPortStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFPortStatsRequest.Builder buildPortStatsRequest() {
        return new OFPortStatsRequestVer14.Builder().setXid(nextXid());
    }

    public OFPortStatus.Builder buildPortStatus() {
        return new OFPortStatusVer14.Builder().setXid(nextXid());
    }

    public OFQueueGetConfigReply.Builder buildQueueGetConfigReply() {
        throw new UnsupportedOperationException("OFQueueGetConfigReply not supported in version 1.4");
    }

    public OFQueueGetConfigRequest.Builder buildQueueGetConfigRequest() {
        throw new UnsupportedOperationException("OFQueueGetConfigRequest not supported in version 1.4");
    }
    public OFQueueGetConfigRequest queueGetConfigRequest(OFPort port) {
        throw new UnsupportedOperationException("OFQueueGetConfigRequest not supported in version 1.4");
    }

    public OFQueueStatsEntry.Builder buildQueueStatsEntry() {
        return new OFQueueStatsEntryVer14.Builder();
    }

    public OFQueueStatsReply.Builder buildQueueStatsReply() {
        return new OFQueueStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFQueueStatsRequest.Builder buildQueueStatsRequest() {
        return new OFQueueStatsRequestVer14.Builder().setXid(nextXid());
    }

    public OFSetConfig.Builder buildSetConfig() {
        return new OFSetConfigVer14.Builder().setXid(nextXid());
    }

    public OFTableMod.Builder buildTableMod() {
        return new OFTableModVer14.Builder().setXid(nextXid());
    }

    public OFTableStatsEntry.Builder buildTableStatsEntry() {
        return new OFTableStatsEntryVer14.Builder();
    }

    public OFTableStatsReply.Builder buildTableStatsReply() {
        return new OFTableStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFTableStatsRequest.Builder buildTableStatsRequest() {
        return new OFTableStatsRequestVer14.Builder().setXid(nextXid());
    }
    public OFTableStatsRequest tableStatsRequest(Set<OFStatsRequestFlags> flags) {
        return new OFTableStatsRequestVer14(
                nextXid(),
                      flags
                    );
    }

    public OFBucket.Builder buildBucket() {
        return new OFBucketVer14.Builder();
    }

    public OFBucketCounter.Builder buildBucketCounter() {
        return new OFBucketCounterVer14.Builder();
    }
    public OFBucketCounter bucketCounter(U64 packetCount, U64 byteCount) {
        return new OFBucketCounterVer14(
                packetCount,
                      byteCount
                    );
    }

    public OFGroupAdd.Builder buildGroupAdd() {
        return new OFGroupAddVer14.Builder().setXid(nextXid());
    }

    public OFGroupDelete.Builder buildGroupDelete() {
        return new OFGroupDeleteVer14.Builder().setXid(nextXid());
    }

    public OFGroupDescStatsEntry.Builder buildGroupDescStatsEntry() {
        return new OFGroupDescStatsEntryVer14.Builder();
    }

    public OFGroupDescStatsReply.Builder buildGroupDescStatsReply() {
        return new OFGroupDescStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFGroupDescStatsRequest.Builder buildGroupDescStatsRequest() {
        return new OFGroupDescStatsRequestVer14.Builder().setXid(nextXid());
    }
    public OFGroupDescStatsRequest groupDescStatsRequest(Set<OFStatsRequestFlags> flags) {
        return new OFGroupDescStatsRequestVer14(
                nextXid(),
                      flags
                    );
    }

    public OFGroupModify.Builder buildGroupModify() {
        return new OFGroupModifyVer14.Builder().setXid(nextXid());
    }

    public OFGroupStatsEntry.Builder buildGroupStatsEntry() {
        return new OFGroupStatsEntryVer14.Builder();
    }

    public OFGroupStatsReply.Builder buildGroupStatsReply() {
        return new OFGroupStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFGroupStatsRequest.Builder buildGroupStatsRequest() {
        return new OFGroupStatsRequestVer14.Builder().setXid(nextXid());
    }

    public OFMatchV2.Builder buildMatchV2() {
        throw new UnsupportedOperationException("OFMatchV2 not supported in version 1.4");
    }

    public OFGroupFeaturesStatsReply.Builder buildGroupFeaturesStatsReply() {
        return new OFGroupFeaturesStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFGroupFeaturesStatsRequest.Builder buildGroupFeaturesStatsRequest() {
        return new OFGroupFeaturesStatsRequestVer14.Builder().setXid(nextXid());
    }
    public OFGroupFeaturesStatsRequest groupFeaturesStatsRequest(Set<OFStatsRequestFlags> flags) {
        return new OFGroupFeaturesStatsRequestVer14(
                nextXid(),
                      flags
                    );
    }

    public OFMatchV3.Builder buildMatchV3() {
        return new OFMatchV3Ver14.Builder();
    }
    public Match.Builder buildMatch() {
        return new OFMatchV3Ver14.Builder();
    }

    final static Match MATCH_WILDCARD_ALL = OFMatchV3Ver14.DEFAULT;

    public Match matchWildcardAll() {
        return MATCH_WILDCARD_ALL;
    }
    public OFMatchV3 matchV3(OFOxmList oxmList) {
        return new OFMatchV3Ver14(
                oxmList
                    );
    }

    public OFRoleReply.Builder buildRoleReply() {
        return new OFRoleReplyVer14.Builder().setXid(nextXid());
    }

    public OFRoleRequest.Builder buildRoleRequest() {
        return new OFRoleRequestVer14.Builder().setXid(nextXid());
    }

    public OFAsyncGetReply.Builder buildAsyncGetReply() {
        return new OFAsyncGetReplyVer14.Builder().setXid(nextXid());
    }

    public OFAsyncGetRequest.Builder buildAsyncGetRequest() {
        return new OFAsyncGetRequestVer14.Builder().setXid(nextXid());
    }
    public OFAsyncGetRequest asyncGetRequest() {
        return new OFAsyncGetRequestVer14(
                nextXid()
                    );
    }

    public OFAsyncSet.Builder buildAsyncSet() {
        return new OFAsyncSetVer14.Builder().setXid(nextXid());
    }

    public OFBsnArpIdle.Builder buildBsnArpIdle() {
        return new OFBsnArpIdleVer14.Builder().setXid(nextXid());
    }

    public OFBsnControllerConnection.Builder buildBsnControllerConnection() {
        return new OFBsnControllerConnectionVer14.Builder();
    }

    public OFBsnControllerConnectionsReply.Builder buildBsnControllerConnectionsReply() {
        return new OFBsnControllerConnectionsReplyVer14.Builder().setXid(nextXid());
    }
    public OFBsnControllerConnectionsReply bsnControllerConnectionsReply(List<OFBsnControllerConnection> connections) {
        return new OFBsnControllerConnectionsReplyVer14(
                nextXid(),
                      connections
                    );
    }

    public OFBsnControllerConnectionsRequest.Builder buildBsnControllerConnectionsRequest() {
        return new OFBsnControllerConnectionsRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnControllerConnectionsRequest bsnControllerConnectionsRequest() {
        return new OFBsnControllerConnectionsRequestVer14(
                nextXid()
                    );
    }

    public OFBsnDebugCounterDescStatsEntry.Builder buildBsnDebugCounterDescStatsEntry() {
        return new OFBsnDebugCounterDescStatsEntryVer14.Builder();
    }

    public OFBsnDebugCounterDescStatsReply.Builder buildBsnDebugCounterDescStatsReply() {
        return new OFBsnDebugCounterDescStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnDebugCounterDescStatsRequest.Builder buildBsnDebugCounterDescStatsRequest() {
        return new OFBsnDebugCounterDescStatsRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnDebugCounterDescStatsRequest bsnDebugCounterDescStatsRequest(Set<OFStatsRequestFlags> flags) {
        return new OFBsnDebugCounterDescStatsRequestVer14(
                nextXid(),
                      flags
                    );
    }

    public OFBsnDebugCounterStatsEntry.Builder buildBsnDebugCounterStatsEntry() {
        return new OFBsnDebugCounterStatsEntryVer14.Builder();
    }
    public OFBsnDebugCounterStatsEntry bsnDebugCounterStatsEntry(U64 counterId, U64 value) {
        return new OFBsnDebugCounterStatsEntryVer14(
                counterId,
                      value
                    );
    }

    public OFBsnDebugCounterStatsReply.Builder buildBsnDebugCounterStatsReply() {
        return new OFBsnDebugCounterStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnDebugCounterStatsRequest.Builder buildBsnDebugCounterStatsRequest() {
        return new OFBsnDebugCounterStatsRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnDebugCounterStatsRequest bsnDebugCounterStatsRequest(Set<OFStatsRequestFlags> flags) {
        return new OFBsnDebugCounterStatsRequestVer14(
                nextXid(),
                      flags
                    );
    }

    public OFBsnFlowChecksumBucketStatsEntry.Builder buildBsnFlowChecksumBucketStatsEntry() {
        return new OFBsnFlowChecksumBucketStatsEntryVer14.Builder();
    }
    public OFBsnFlowChecksumBucketStatsEntry bsnFlowChecksumBucketStatsEntry(U64 checksum) {
        return new OFBsnFlowChecksumBucketStatsEntryVer14(
                checksum
                    );
    }

    public OFBsnFlowChecksumBucketStatsReply.Builder buildBsnFlowChecksumBucketStatsReply() {
        return new OFBsnFlowChecksumBucketStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnFlowChecksumBucketStatsRequest.Builder buildBsnFlowChecksumBucketStatsRequest() {
        return new OFBsnFlowChecksumBucketStatsRequestVer14.Builder().setXid(nextXid());
    }

    public OFBsnFlowIdle.Builder buildBsnFlowIdle() {
        return new OFBsnFlowIdleVer14.Builder().setXid(nextXid());
    }

    public OFBsnFlowIdleEnableGetReply.Builder buildBsnFlowIdleEnableGetReply() {
        return new OFBsnFlowIdleEnableGetReplyVer14.Builder().setXid(nextXid());
    }
    public OFBsnFlowIdleEnableGetReply bsnFlowIdleEnableGetReply(long enabled) {
        return new OFBsnFlowIdleEnableGetReplyVer14(
                nextXid(),
                      enabled
                    );
    }

    public OFBsnFlowIdleEnableGetRequest.Builder buildBsnFlowIdleEnableGetRequest() {
        return new OFBsnFlowIdleEnableGetRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnFlowIdleEnableGetRequest bsnFlowIdleEnableGetRequest() {
        return new OFBsnFlowIdleEnableGetRequestVer14(
                nextXid()
                    );
    }

    public OFBsnFlowIdleEnableSetReply.Builder buildBsnFlowIdleEnableSetReply() {
        return new OFBsnFlowIdleEnableSetReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnFlowIdleEnableSetRequest.Builder buildBsnFlowIdleEnableSetRequest() {
        return new OFBsnFlowIdleEnableSetRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnFlowIdleEnableSetRequest bsnFlowIdleEnableSetRequest(long enable) {
        return new OFBsnFlowIdleEnableSetRequestVer14(
                nextXid(),
                      enable
                    );
    }

    public OFBsnGenericStatsEntry.Builder buildBsnGenericStatsEntry() {
        return new OFBsnGenericStatsEntryVer14.Builder();
    }
    public OFBsnGenericStatsEntry bsnGenericStatsEntry(List<OFBsnTlv> tlvs) {
        return new OFBsnGenericStatsEntryVer14(
                tlvs
                    );
    }

    public OFBsnGenericStatsReply.Builder buildBsnGenericStatsReply() {
        return new OFBsnGenericStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnGenericStatsRequest.Builder buildBsnGenericStatsRequest() {
        return new OFBsnGenericStatsRequestVer14.Builder().setXid(nextXid());
    }

    public OFBsnGentableBucketStatsEntry.Builder buildBsnGentableBucketStatsEntry() {
        return new OFBsnGentableBucketStatsEntryVer14.Builder();
    }
    public OFBsnGentableBucketStatsEntry bsnGentableBucketStatsEntry(U128 checksum) {
        return new OFBsnGentableBucketStatsEntryVer14(
                checksum
                    );
    }

    public OFBsnGentableBucketStatsReply.Builder buildBsnGentableBucketStatsReply() {
        return new OFBsnGentableBucketStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnGentableBucketStatsRequest.Builder buildBsnGentableBucketStatsRequest() {
        return new OFBsnGentableBucketStatsRequestVer14.Builder().setXid(nextXid());
    }

    public OFBsnGentableClearReply.Builder buildBsnGentableClearReply() {
        return new OFBsnGentableClearReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnGentableClearRequest.Builder buildBsnGentableClearRequest() {
        return new OFBsnGentableClearRequestVer14.Builder().setXid(nextXid());
    }

    public OFBsnGentableDescStatsEntry.Builder buildBsnGentableDescStatsEntry() {
        return new OFBsnGentableDescStatsEntryVer14.Builder();
    }

    public OFBsnGentableDescStatsReply.Builder buildBsnGentableDescStatsReply() {
        return new OFBsnGentableDescStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnGentableDescStatsRequest.Builder buildBsnGentableDescStatsRequest() {
        return new OFBsnGentableDescStatsRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnGentableDescStatsRequest bsnGentableDescStatsRequest(Set<OFStatsRequestFlags> flags) {
        return new OFBsnGentableDescStatsRequestVer14(
                nextXid(),
                      flags
                    );
    }

    public OFBsnGentableEntryAdd.Builder buildBsnGentableEntryAdd() {
        return new OFBsnGentableEntryAddVer14.Builder().setXid(nextXid());
    }

    public OFBsnGentableEntryDelete.Builder buildBsnGentableEntryDelete() {
        return new OFBsnGentableEntryDeleteVer14.Builder().setXid(nextXid());
    }

    public OFBsnGentableEntryDescStatsEntry.Builder buildBsnGentableEntryDescStatsEntry() {
        return new OFBsnGentableEntryDescStatsEntryVer14.Builder();
    }

    public OFBsnGentableEntryDescStatsReply.Builder buildBsnGentableEntryDescStatsReply() {
        return new OFBsnGentableEntryDescStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnGentableEntryDescStatsRequest.Builder buildBsnGentableEntryDescStatsRequest() {
        return new OFBsnGentableEntryDescStatsRequestVer14.Builder().setXid(nextXid());
    }

    public OFBsnGentableEntryStatsEntry.Builder buildBsnGentableEntryStatsEntry() {
        return new OFBsnGentableEntryStatsEntryVer14.Builder();
    }
    public OFBsnGentableEntryStatsEntry bsnGentableEntryStatsEntry(List<OFBsnTlv> key, List<OFBsnTlv> stats) {
        return new OFBsnGentableEntryStatsEntryVer14(
                key,
                      stats
                    );
    }

    public OFBsnGentableEntryStatsReply.Builder buildBsnGentableEntryStatsReply() {
        return new OFBsnGentableEntryStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnGentableEntryStatsRequest.Builder buildBsnGentableEntryStatsRequest() {
        return new OFBsnGentableEntryStatsRequestVer14.Builder().setXid(nextXid());
    }

    public OFBsnGentableSetBucketsSize.Builder buildBsnGentableSetBucketsSize() {
        return new OFBsnGentableSetBucketsSizeVer14.Builder().setXid(nextXid());
    }

    public OFBsnGentableStatsEntry.Builder buildBsnGentableStatsEntry() {
        return new OFBsnGentableStatsEntryVer14.Builder();
    }

    public OFBsnGentableStatsReply.Builder buildBsnGentableStatsReply() {
        return new OFBsnGentableStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnGentableStatsRequest.Builder buildBsnGentableStatsRequest() {
        return new OFBsnGentableStatsRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnGentableStatsRequest bsnGentableStatsRequest(Set<OFStatsRequestFlags> flags) {
        return new OFBsnGentableStatsRequestVer14(
                nextXid(),
                      flags
                    );
    }

    public OFBsnGetSwitchPipelineReply.Builder buildBsnGetSwitchPipelineReply() {
        return new OFBsnGetSwitchPipelineReplyVer14.Builder().setXid(nextXid());
    }
    public OFBsnGetSwitchPipelineReply bsnGetSwitchPipelineReply(String pipeline) {
        return new OFBsnGetSwitchPipelineReplyVer14(
                nextXid(),
                      pipeline
                    );
    }

    public OFBsnGetSwitchPipelineRequest.Builder buildBsnGetSwitchPipelineRequest() {
        return new OFBsnGetSwitchPipelineRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnGetSwitchPipelineRequest bsnGetSwitchPipelineRequest() {
        return new OFBsnGetSwitchPipelineRequestVer14(
                nextXid()
                    );
    }

    public OFBsnImageDescStatsReply.Builder buildBsnImageDescStatsReply() {
        return new OFBsnImageDescStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnImageDescStatsRequest.Builder buildBsnImageDescStatsRequest() {
        return new OFBsnImageDescStatsRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnImageDescStatsRequest bsnImageDescStatsRequest(Set<OFStatsRequestFlags> flags) {
        return new OFBsnImageDescStatsRequestVer14(
                nextXid(),
                      flags
                    );
    }

    public OFBsnLacpConvergenceNotif.Builder buildBsnLacpConvergenceNotif() {
        return new OFBsnLacpConvergenceNotifVer14.Builder().setXid(nextXid());
    }

    public OFBsnLacpStatsEntry.Builder buildBsnLacpStatsEntry() {
        return new OFBsnLacpStatsEntryVer14.Builder();
    }

    public OFBsnLacpStatsReply.Builder buildBsnLacpStatsReply() {
        return new OFBsnLacpStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnLacpStatsRequest.Builder buildBsnLacpStatsRequest() {
        return new OFBsnLacpStatsRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnLacpStatsRequest bsnLacpStatsRequest(Set<OFStatsRequestFlags> flags) {
        return new OFBsnLacpStatsRequestVer14(
                nextXid(),
                      flags
                    );
    }

    public OFBsnLog.Builder buildBsnLog() {
        return new OFBsnLogVer14.Builder().setXid(nextXid());
    }

    public OFBsnLuaCommandReply.Builder buildBsnLuaCommandReply() {
        return new OFBsnLuaCommandReplyVer14.Builder().setXid(nextXid());
    }
    public OFBsnLuaCommandReply bsnLuaCommandReply(byte[] data) {
        return new OFBsnLuaCommandReplyVer14(
                nextXid(),
                      data
                    );
    }

    public OFBsnLuaCommandRequest.Builder buildBsnLuaCommandRequest() {
        return new OFBsnLuaCommandRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnLuaCommandRequest bsnLuaCommandRequest(byte[] data) {
        return new OFBsnLuaCommandRequestVer14(
                nextXid(),
                      data
                    );
    }

    public OFBsnLuaNotification.Builder buildBsnLuaNotification() {
        return new OFBsnLuaNotificationVer14.Builder().setXid(nextXid());
    }
    public OFBsnLuaNotification bsnLuaNotification(byte[] data) {
        return new OFBsnLuaNotificationVer14(
                nextXid(),
                      data
                    );
    }

    public OFBsnLuaUpload.Builder buildBsnLuaUpload() {
        return new OFBsnLuaUploadVer14.Builder().setXid(nextXid());
    }

    public OFBsnPortCounterStatsEntry.Builder buildBsnPortCounterStatsEntry() {
        return new OFBsnPortCounterStatsEntryVer14.Builder();
    }
    public OFBsnPortCounterStatsEntry bsnPortCounterStatsEntry(OFPort portNo, List<U64> values) {
        return new OFBsnPortCounterStatsEntryVer14(
                portNo,
                      values
                    );
    }

    public OFBsnPortCounterStatsReply.Builder buildBsnPortCounterStatsReply() {
        return new OFBsnPortCounterStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnPortCounterStatsRequest.Builder buildBsnPortCounterStatsRequest() {
        return new OFBsnPortCounterStatsRequestVer14.Builder().setXid(nextXid());
    }

    public OFBsnRoleStatus.Builder buildBsnRoleStatus() {
        throw new UnsupportedOperationException("OFBsnRoleStatus not supported in version 1.4");
    }

    public OFBsnSetAuxCxnsReply.Builder buildBsnSetAuxCxnsReply() {
        return new OFBsnSetAuxCxnsReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnSetAuxCxnsRequest.Builder buildBsnSetAuxCxnsRequest() {
        return new OFBsnSetAuxCxnsRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnSetAuxCxnsRequest bsnSetAuxCxnsRequest(long numAux) {
        return new OFBsnSetAuxCxnsRequestVer14(
                nextXid(),
                      numAux
                    );
    }

    public OFBsnSetLacpReply.Builder buildBsnSetLacpReply() {
        return new OFBsnSetLacpReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnSetLacpRequest.Builder buildBsnSetLacpRequest() {
        return new OFBsnSetLacpRequestVer14.Builder().setXid(nextXid());
    }

    public OFBsnSetSwitchPipelineReply.Builder buildBsnSetSwitchPipelineReply() {
        return new OFBsnSetSwitchPipelineReplyVer14.Builder().setXid(nextXid());
    }
    public OFBsnSetSwitchPipelineReply bsnSetSwitchPipelineReply(long status) {
        return new OFBsnSetSwitchPipelineReplyVer14(
                nextXid(),
                      status
                    );
    }

    public OFBsnSetSwitchPipelineRequest.Builder buildBsnSetSwitchPipelineRequest() {
        return new OFBsnSetSwitchPipelineRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnSetSwitchPipelineRequest bsnSetSwitchPipelineRequest(String pipeline) {
        return new OFBsnSetSwitchPipelineRequestVer14(
                nextXid(),
                      pipeline
                    );
    }

    public OFBsnSwitchPipelineStatsEntry.Builder buildBsnSwitchPipelineStatsEntry() {
        return new OFBsnSwitchPipelineStatsEntryVer14.Builder();
    }
    public OFBsnSwitchPipelineStatsEntry bsnSwitchPipelineStatsEntry(String pipeline) {
        return new OFBsnSwitchPipelineStatsEntryVer14(
                pipeline
                    );
    }

    public OFBsnSwitchPipelineStatsReply.Builder buildBsnSwitchPipelineStatsReply() {
        return new OFBsnSwitchPipelineStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnSwitchPipelineStatsRequest.Builder buildBsnSwitchPipelineStatsRequest() {
        return new OFBsnSwitchPipelineStatsRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnSwitchPipelineStatsRequest bsnSwitchPipelineStatsRequest(Set<OFStatsRequestFlags> flags) {
        return new OFBsnSwitchPipelineStatsRequestVer14(
                nextXid(),
                      flags
                    );
    }

    public OFBsnTableChecksumStatsEntry.Builder buildBsnTableChecksumStatsEntry() {
        return new OFBsnTableChecksumStatsEntryVer14.Builder();
    }
    public OFBsnTableChecksumStatsEntry bsnTableChecksumStatsEntry(TableId tableId, U64 checksum) {
        return new OFBsnTableChecksumStatsEntryVer14(
                tableId,
                      checksum
                    );
    }

    public OFBsnTableChecksumStatsReply.Builder buildBsnTableChecksumStatsReply() {
        return new OFBsnTableChecksumStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnTableChecksumStatsRequest.Builder buildBsnTableChecksumStatsRequest() {
        return new OFBsnTableChecksumStatsRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnTableChecksumStatsRequest bsnTableChecksumStatsRequest(Set<OFStatsRequestFlags> flags) {
        return new OFBsnTableChecksumStatsRequestVer14(
                nextXid(),
                      flags
                    );
    }

    public OFBsnTableSetBucketsSize.Builder buildBsnTableSetBucketsSize() {
        return new OFBsnTableSetBucketsSizeVer14.Builder().setXid(nextXid());
    }

    public OFBsnTimeReply.Builder buildBsnTimeReply() {
        return new OFBsnTimeReplyVer14.Builder().setXid(nextXid());
    }
    public OFBsnTimeReply bsnTimeReply(U64 timeMs) {
        return new OFBsnTimeReplyVer14(
                nextXid(),
                      timeMs
                    );
    }

    public OFBsnTimeRequest.Builder buildBsnTimeRequest() {
        return new OFBsnTimeRequestVer14.Builder().setXid(nextXid());
    }
    public OFBsnTimeRequest bsnTimeRequest() {
        return new OFBsnTimeRequestVer14(
                nextXid()
                    );
    }

    public OFBsnVlanCounterClear.Builder buildBsnVlanCounterClear() {
        return new OFBsnVlanCounterClearVer14.Builder().setXid(nextXid());
    }
    public OFBsnVlanCounterClear bsnVlanCounterClear(int vlanVid) {
        return new OFBsnVlanCounterClearVer14(
                nextXid(),
                      vlanVid
                    );
    }

    public OFBsnVlanCounterStatsEntry.Builder buildBsnVlanCounterStatsEntry() {
        return new OFBsnVlanCounterStatsEntryVer14.Builder();
    }
    public OFBsnVlanCounterStatsEntry bsnVlanCounterStatsEntry(int vlanVid, List<U64> values) {
        return new OFBsnVlanCounterStatsEntryVer14(
                vlanVid,
                      values
                    );
    }

    public OFBsnVlanCounterStatsReply.Builder buildBsnVlanCounterStatsReply() {
        return new OFBsnVlanCounterStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnVlanCounterStatsRequest.Builder buildBsnVlanCounterStatsRequest() {
        return new OFBsnVlanCounterStatsRequestVer14.Builder().setXid(nextXid());
    }

    public OFBsnVrfCounterStatsEntry.Builder buildBsnVrfCounterStatsEntry() {
        return new OFBsnVrfCounterStatsEntryVer14.Builder();
    }
    public OFBsnVrfCounterStatsEntry bsnVrfCounterStatsEntry(long vrf, List<U64> values) {
        return new OFBsnVrfCounterStatsEntryVer14(
                vrf,
                      values
                    );
    }

    public OFBsnVrfCounterStatsReply.Builder buildBsnVrfCounterStatsReply() {
        return new OFBsnVrfCounterStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFBsnVrfCounterStatsRequest.Builder buildBsnVrfCounterStatsRequest() {
        return new OFBsnVrfCounterStatsRequestVer14.Builder().setXid(nextXid());
    }

    public OFHelloElemVersionbitmap.Builder buildHelloElemVersionbitmap() {
        return new OFHelloElemVersionbitmapVer14.Builder();
    }
    public OFHelloElemVersionbitmap helloElemVersionbitmap(List<U32> bitmaps) {
        return new OFHelloElemVersionbitmapVer14(
                bitmaps
                    );
    }

    public OFMeterBandStats.Builder buildMeterBandStats() {
        return new OFMeterBandStatsVer14.Builder();
    }
    public OFMeterBandStats meterBandStats(U64 packetBandCount, U64 byteBandCount) {
        return new OFMeterBandStatsVer14(
                packetBandCount,
                      byteBandCount
                    );
    }

    public OFMeterConfig.Builder buildMeterConfig() {
        return new OFMeterConfigVer14.Builder();
    }

    public OFMeterConfigStatsReply.Builder buildMeterConfigStatsReply() {
        return new OFMeterConfigStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFMeterConfigStatsRequest.Builder buildMeterConfigStatsRequest() {
        return new OFMeterConfigStatsRequestVer14.Builder().setXid(nextXid());
    }

    public OFMeterFeatures.Builder buildMeterFeatures() {
        return new OFMeterFeaturesVer14.Builder();
    }

    public OFMeterFeaturesStatsReply.Builder buildMeterFeaturesStatsReply() {
        return new OFMeterFeaturesStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFMeterFeaturesStatsRequest.Builder buildMeterFeaturesStatsRequest() {
        return new OFMeterFeaturesStatsRequestVer14.Builder().setXid(nextXid());
    }
    public OFMeterFeaturesStatsRequest meterFeaturesStatsRequest(Set<OFStatsRequestFlags> flags) {
        return new OFMeterFeaturesStatsRequestVer14(
                nextXid(),
                      flags
                    );
    }

    public OFMeterMod.Builder buildMeterMod() {
        return new OFMeterModVer14.Builder().setXid(nextXid());
    }

    public OFMeterStats.Builder buildMeterStats() {
        return new OFMeterStatsVer14.Builder();
    }

    public OFMeterStatsReply.Builder buildMeterStatsReply() {
        return new OFMeterStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFMeterStatsRequest.Builder buildMeterStatsRequest() {
        return new OFMeterStatsRequestVer14.Builder().setXid(nextXid());
    }

    public OFPortDescStatsReply.Builder buildPortDescStatsReply() {
        return new OFPortDescStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFPortDescStatsRequest.Builder buildPortDescStatsRequest() {
        return new OFPortDescStatsRequestVer14.Builder().setXid(nextXid());
    }
    public OFPortDescStatsRequest portDescStatsRequest(Set<OFStatsRequestFlags> flags) {
        return new OFPortDescStatsRequestVer14(
                nextXid(),
                      flags
                    );
    }

    public OFTableFeaturePropApplyActions.Builder buildTableFeaturePropApplyActions() {
        return new OFTableFeaturePropApplyActionsVer14.Builder();
    }
    public OFTableFeaturePropApplyActions tableFeaturePropApplyActions(List<OFActionId> actionIds) {
        return new OFTableFeaturePropApplyActionsVer14(
                actionIds
                    );
    }

    public OFTableFeaturePropApplyActionsMiss.Builder buildTableFeaturePropApplyActionsMiss() {
        return new OFTableFeaturePropApplyActionsMissVer14.Builder();
    }
    public OFTableFeaturePropApplyActionsMiss tableFeaturePropApplyActionsMiss(List<OFActionId> actionIds) {
        return new OFTableFeaturePropApplyActionsMissVer14(
                actionIds
                    );
    }

    public OFTableFeaturePropApplySetfield.Builder buildTableFeaturePropApplySetfield() {
        return new OFTableFeaturePropApplySetfieldVer14.Builder();
    }
    public OFTableFeaturePropApplySetfield tableFeaturePropApplySetfield(List<U32> oxmIds) {
        return new OFTableFeaturePropApplySetfieldVer14(
                oxmIds
                    );
    }

    public OFTableFeaturePropApplySetfieldMiss.Builder buildTableFeaturePropApplySetfieldMiss() {
        return new OFTableFeaturePropApplySetfieldMissVer14.Builder();
    }
    public OFTableFeaturePropApplySetfieldMiss tableFeaturePropApplySetfieldMiss(List<U32> oxmIds) {
        return new OFTableFeaturePropApplySetfieldMissVer14(
                oxmIds
                    );
    }

    public OFTableFeaturePropInstructions.Builder buildTableFeaturePropInstructions() {
        return new OFTableFeaturePropInstructionsVer14.Builder();
    }
    public OFTableFeaturePropInstructions tableFeaturePropInstructions(List<OFInstructionId> instructionIds) {
        return new OFTableFeaturePropInstructionsVer14(
                instructionIds
                    );
    }

    public OFTableFeaturePropInstructionsMiss.Builder buildTableFeaturePropInstructionsMiss() {
        return new OFTableFeaturePropInstructionsMissVer14.Builder();
    }
    public OFTableFeaturePropInstructionsMiss tableFeaturePropInstructionsMiss(List<OFInstructionId> instructionIds) {
        return new OFTableFeaturePropInstructionsMissVer14(
                instructionIds
                    );
    }

    public OFTableFeaturePropMatch.Builder buildTableFeaturePropMatch() {
        return new OFTableFeaturePropMatchVer14.Builder();
    }
    public OFTableFeaturePropMatch tableFeaturePropMatch(List<U32> oxmIds) {
        return new OFTableFeaturePropMatchVer14(
                oxmIds
                    );
    }

    public OFTableFeaturePropNextTables.Builder buildTableFeaturePropNextTables() {
        return new OFTableFeaturePropNextTablesVer14.Builder();
    }
    public OFTableFeaturePropNextTables tableFeaturePropNextTables(List<U8> nextTableIds) {
        return new OFTableFeaturePropNextTablesVer14(
                nextTableIds
                    );
    }

    public OFTableFeaturePropNextTablesMiss.Builder buildTableFeaturePropNextTablesMiss() {
        return new OFTableFeaturePropNextTablesMissVer14.Builder();
    }
    public OFTableFeaturePropNextTablesMiss tableFeaturePropNextTablesMiss(List<U8> nextTableIds) {
        return new OFTableFeaturePropNextTablesMissVer14(
                nextTableIds
                    );
    }

    public OFTableFeaturePropWildcards.Builder buildTableFeaturePropWildcards() {
        return new OFTableFeaturePropWildcardsVer14.Builder();
    }
    public OFTableFeaturePropWildcards tableFeaturePropWildcards(List<U32> oxmIds) {
        return new OFTableFeaturePropWildcardsVer14(
                oxmIds
                    );
    }

    public OFTableFeaturePropWriteActions.Builder buildTableFeaturePropWriteActions() {
        return new OFTableFeaturePropWriteActionsVer14.Builder();
    }
    public OFTableFeaturePropWriteActions tableFeaturePropWriteActions(List<OFActionId> actionIds) {
        return new OFTableFeaturePropWriteActionsVer14(
                actionIds
                    );
    }

    public OFTableFeaturePropWriteActionsMiss.Builder buildTableFeaturePropWriteActionsMiss() {
        return new OFTableFeaturePropWriteActionsMissVer14.Builder();
    }
    public OFTableFeaturePropWriteActionsMiss tableFeaturePropWriteActionsMiss(List<OFActionId> actionIds) {
        return new OFTableFeaturePropWriteActionsMissVer14(
                actionIds
                    );
    }

    public OFTableFeaturePropWriteSetfield.Builder buildTableFeaturePropWriteSetfield() {
        return new OFTableFeaturePropWriteSetfieldVer14.Builder();
    }
    public OFTableFeaturePropWriteSetfield tableFeaturePropWriteSetfield(List<U32> oxmIds) {
        return new OFTableFeaturePropWriteSetfieldVer14(
                oxmIds
                    );
    }

    public OFTableFeaturePropWriteSetfieldMiss.Builder buildTableFeaturePropWriteSetfieldMiss() {
        return new OFTableFeaturePropWriteSetfieldMissVer14.Builder();
    }
    public OFTableFeaturePropWriteSetfieldMiss tableFeaturePropWriteSetfieldMiss(List<U32> oxmIds) {
        return new OFTableFeaturePropWriteSetfieldMissVer14(
                oxmIds
                    );
    }

    public OFTableFeatures.Builder buildTableFeatures() {
        return new OFTableFeaturesVer14.Builder();
    }

    public OFTableFeaturesStatsReply.Builder buildTableFeaturesStatsReply() {
        return new OFTableFeaturesStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFTableFeaturesStatsRequest.Builder buildTableFeaturesStatsRequest() {
        return new OFTableFeaturesStatsRequestVer14.Builder().setXid(nextXid());
    }

    public OFUint64.Builder buildUint64() {
        return new OFUint64Ver14.Builder();
    }
    public OFUint64 uint64(U64 value) {
        return new OFUint64Ver14(
                value
                    );
    }

    public OFAsyncConfigPropExperimenterMaster asyncConfigPropExperimenterMaster() {
        return OFAsyncConfigPropExperimenterMasterVer14.INSTANCE;
    }

    public OFAsyncConfigPropExperimenterSlave asyncConfigPropExperimenterSlave() {
        return OFAsyncConfigPropExperimenterSlaveVer14.INSTANCE;
    }

    public OFAsyncConfigPropFlowRemovedMaster.Builder buildAsyncConfigPropFlowRemovedMaster() {
        return new OFAsyncConfigPropFlowRemovedMasterVer14.Builder();
    }
    public OFAsyncConfigPropFlowRemovedMaster asyncConfigPropFlowRemovedMaster(long mask) {
        return new OFAsyncConfigPropFlowRemovedMasterVer14(
                mask
                    );
    }

    public OFAsyncConfigPropFlowRemovedSlave.Builder buildAsyncConfigPropFlowRemovedSlave() {
        return new OFAsyncConfigPropFlowRemovedSlaveVer14.Builder();
    }
    public OFAsyncConfigPropFlowRemovedSlave asyncConfigPropFlowRemovedSlave(long mask) {
        return new OFAsyncConfigPropFlowRemovedSlaveVer14(
                mask
                    );
    }

    public OFAsyncConfigPropPacketInMaster.Builder buildAsyncConfigPropPacketInMaster() {
        return new OFAsyncConfigPropPacketInMasterVer14.Builder();
    }
    public OFAsyncConfigPropPacketInMaster asyncConfigPropPacketInMaster(long mask) {
        return new OFAsyncConfigPropPacketInMasterVer14(
                mask
                    );
    }

    public OFAsyncConfigPropPacketInSlave.Builder buildAsyncConfigPropPacketInSlave() {
        return new OFAsyncConfigPropPacketInSlaveVer14.Builder();
    }
    public OFAsyncConfigPropPacketInSlave asyncConfigPropPacketInSlave(long mask) {
        return new OFAsyncConfigPropPacketInSlaveVer14(
                mask
                    );
    }

    public OFAsyncConfigPropPortStatusMaster.Builder buildAsyncConfigPropPortStatusMaster() {
        return new OFAsyncConfigPropPortStatusMasterVer14.Builder();
    }
    public OFAsyncConfigPropPortStatusMaster asyncConfigPropPortStatusMaster(long mask) {
        return new OFAsyncConfigPropPortStatusMasterVer14(
                mask
                    );
    }

    public OFAsyncConfigPropPortStatusSlave.Builder buildAsyncConfigPropPortStatusSlave() {
        return new OFAsyncConfigPropPortStatusSlaveVer14.Builder();
    }
    public OFAsyncConfigPropPortStatusSlave asyncConfigPropPortStatusSlave(long mask) {
        return new OFAsyncConfigPropPortStatusSlaveVer14(
                mask
                    );
    }

    public OFAsyncConfigPropRequestforwardMaster.Builder buildAsyncConfigPropRequestforwardMaster() {
        return new OFAsyncConfigPropRequestforwardMasterVer14.Builder();
    }
    public OFAsyncConfigPropRequestforwardMaster asyncConfigPropRequestforwardMaster(long mask) {
        return new OFAsyncConfigPropRequestforwardMasterVer14(
                mask
                    );
    }

    public OFAsyncConfigPropRequestforwardSlave.Builder buildAsyncConfigPropRequestforwardSlave() {
        return new OFAsyncConfigPropRequestforwardSlaveVer14.Builder();
    }
    public OFAsyncConfigPropRequestforwardSlave asyncConfigPropRequestforwardSlave(long mask) {
        return new OFAsyncConfigPropRequestforwardSlaveVer14(
                mask
                    );
    }

    public OFAsyncConfigPropRoleStatusMaster.Builder buildAsyncConfigPropRoleStatusMaster() {
        return new OFAsyncConfigPropRoleStatusMasterVer14.Builder();
    }
    public OFAsyncConfigPropRoleStatusMaster asyncConfigPropRoleStatusMaster(long mask) {
        return new OFAsyncConfigPropRoleStatusMasterVer14(
                mask
                    );
    }

    public OFAsyncConfigPropRoleStatusSlave.Builder buildAsyncConfigPropRoleStatusSlave() {
        return new OFAsyncConfigPropRoleStatusSlaveVer14.Builder();
    }
    public OFAsyncConfigPropRoleStatusSlave asyncConfigPropRoleStatusSlave(long mask) {
        return new OFAsyncConfigPropRoleStatusSlaveVer14(
                mask
                    );
    }

    public OFAsyncConfigPropTableStatusMaster.Builder buildAsyncConfigPropTableStatusMaster() {
        return new OFAsyncConfigPropTableStatusMasterVer14.Builder();
    }
    public OFAsyncConfigPropTableStatusMaster asyncConfigPropTableStatusMaster(long mask) {
        return new OFAsyncConfigPropTableStatusMasterVer14(
                mask
                    );
    }

    public OFAsyncConfigPropTableStatusSlave.Builder buildAsyncConfigPropTableStatusSlave() {
        return new OFAsyncConfigPropTableStatusSlaveVer14.Builder();
    }
    public OFAsyncConfigPropTableStatusSlave asyncConfigPropTableStatusSlave(long mask) {
        return new OFAsyncConfigPropTableStatusSlaveVer14(
                mask
                    );
    }

    public OFBsnGenericAsync.Builder buildBsnGenericAsync() {
        return new OFBsnGenericAsyncVer14.Builder().setXid(nextXid());
    }

    public OFBsnTakeover.Builder buildBsnTakeover() {
        return new OFBsnTakeoverVer14.Builder().setXid(nextXid());
    }
    public OFBsnTakeover bsnTakeover() {
        return new OFBsnTakeoverVer14(
                nextXid()
                    );
    }

    public OFBundleAddMsg.Builder buildBundleAddMsg() {
        return new OFBundleAddMsgVer14.Builder().setXid(nextXid());
    }

    public OFBundleCtrlMsg.Builder buildBundleCtrlMsg() {
        return new OFBundleCtrlMsgVer14.Builder().setXid(nextXid());
    }

    public OFPortDescPropBsnGenerationId.Builder buildPortDescPropBsnGenerationId() {
        return new OFPortDescPropBsnGenerationIdVer14.Builder();
    }
    public OFPortDescPropBsnGenerationId portDescPropBsnGenerationId(U64 generationId) {
        return new OFPortDescPropBsnGenerationIdVer14(
                generationId
                    );
    }

    public OFPortDescPropBsnUplink portDescPropBsnUplink() {
        return OFPortDescPropBsnUplinkVer14.INSTANCE;
    }

    public OFPortDescPropEthernet.Builder buildPortDescPropEthernet() {
        return new OFPortDescPropEthernetVer14.Builder();
    }

    public OFPortDescPropOptical.Builder buildPortDescPropOptical() {
        return new OFPortDescPropOpticalVer14.Builder();
    }

    public OFPortModPropEthernet.Builder buildPortModPropEthernet() {
        return new OFPortModPropEthernetVer14.Builder();
    }
    public OFPortModPropEthernet portModPropEthernet(long advertise) {
        return new OFPortModPropEthernetVer14(
                advertise
                    );
    }

    public OFPortModPropOptical.Builder buildPortModPropOptical() {
        return new OFPortModPropOpticalVer14.Builder();
    }

    public OFPortStatsPropEthernet.Builder buildPortStatsPropEthernet() {
        return new OFPortStatsPropEthernetVer14.Builder();
    }

    public OFPortStatsPropOptical.Builder buildPortStatsPropOptical() {
        return new OFPortStatsPropOpticalVer14.Builder();
    }

    public OFQueueDesc.Builder buildQueueDesc() {
        return new OFQueueDescVer14.Builder();
    }

    public OFQueueDescPropMaxRate.Builder buildQueueDescPropMaxRate() {
        return new OFQueueDescPropMaxRateVer14.Builder();
    }
    public OFQueueDescPropMaxRate queueDescPropMaxRate(int rate) {
        return new OFQueueDescPropMaxRateVer14(
                rate
                    );
    }

    public OFQueueDescPropMinRate.Builder buildQueueDescPropMinRate() {
        return new OFQueueDescPropMinRateVer14.Builder();
    }
    public OFQueueDescPropMinRate queueDescPropMinRate(int rate) {
        return new OFQueueDescPropMinRateVer14(
                rate
                    );
    }

    public OFQueueDescStatsReply.Builder buildQueueDescStatsReply() {
        return new OFQueueDescStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFQueueDescStatsRequest.Builder buildQueueDescStatsRequest() {
        return new OFQueueDescStatsRequestVer14.Builder().setXid(nextXid());
    }
    public OFQueueDescStatsRequest queueDescStatsRequest(Set<OFStatsRequestFlags> flags) {
        return new OFQueueDescStatsRequestVer14(
                nextXid(),
                      flags
                    );
    }

    public OFRequestforward.Builder buildRequestforward() {
        return new OFRequestforwardVer14.Builder().setXid(nextXid());
    }

    public OFRoleStatus.Builder buildRoleStatus() {
        return new OFRoleStatusVer14.Builder().setXid(nextXid());
    }

    public OFTableDesc.Builder buildTableDesc() {
        return new OFTableDescVer14.Builder();
    }
    public OFTableDesc tableDesc(TableId tableId, Set<OFTableConfig> config) {
        return new OFTableDescVer14(
                tableId,
                      config
                    );
    }

    public OFTableDescStatsReply.Builder buildTableDescStatsReply() {
        return new OFTableDescStatsReplyVer14.Builder().setXid(nextXid());
    }

    public OFTableDescStatsRequest.Builder buildTableDescStatsRequest() {
        return new OFTableDescStatsRequestVer14.Builder().setXid(nextXid());
    }
    public OFTableDescStatsRequest tableDescStatsRequest(Set<OFStatsRequestFlags> flags) {
        return new OFTableDescStatsRequestVer14(
                nextXid(),
                      flags
                    );
    }

    public OFTableFeaturePropTableSyncFrom.Builder buildTableFeaturePropTableSyncFrom() {
        return new OFTableFeaturePropTableSyncFromVer14.Builder();
    }
    public OFTableFeaturePropTableSyncFrom tableFeaturePropTableSyncFrom(List<U8> tableIds) {
        return new OFTableFeaturePropTableSyncFromVer14(
                tableIds
                    );
    }

    public OFTableModPropEviction.Builder buildTableModPropEviction() {
        return new OFTableModPropEvictionVer14.Builder();
    }
    public OFTableModPropEviction tableModPropEviction(Set<OFTableModPropEvictionFlag> flags) {
        return new OFTableModPropEvictionVer14(
                flags
                    );
    }

    public OFTableModPropVacancy.Builder buildTableModPropVacancy() {
        return new OFTableModPropVacancyVer14.Builder();
    }

    public OFTableStatus.Builder buildTableStatus() {
        return new OFTableStatusVer14.Builder().setXid(nextXid());
    }

    public OFMessageReader<OFMessage> getReader() {
        return OFMessageVer14.READER;
    }

    public long nextXid() {
        return xidGenerator.nextXid();
    }

    public OFVersion getVersion() {
            return OFVersion.OF_14;
    }
}
