// Copyright (c) 2008 The Board of Trustees of The Leland Stanford Junior University
// Copyright (c) 2011, 2012 Open Networking Foundation
// Copyright (c) 2012, 2013 Big Switch Networks, Inc.
// This library was generated by the LoxiGen Compiler.
// See the file LICENSE.txt which should have been included in the source distribution

// Automatically generated by LOXI from template const_set_serializer.java
// Do not modify

package org.projectfloodlight.openflow.protocol.ver14;

import org.projectfloodlight.openflow.protocol.*;
import org.projectfloodlight.openflow.protocol.action.*;
import org.projectfloodlight.openflow.protocol.actionid.*;
import org.projectfloodlight.openflow.protocol.bsntlv.*;
import org.projectfloodlight.openflow.protocol.errormsg.*;
import org.projectfloodlight.openflow.protocol.meterband.*;
import org.projectfloodlight.openflow.protocol.instruction.*;
import org.projectfloodlight.openflow.protocol.instructionid.*;
import org.projectfloodlight.openflow.protocol.match.*;
import org.projectfloodlight.openflow.protocol.oxm.*;
import org.projectfloodlight.openflow.protocol.queueprop.*;
import org.projectfloodlight.openflow.types.*;
import org.projectfloodlight.openflow.util.*;
import org.projectfloodlight.openflow.exceptions.*;
import org.projectfloodlight.openflow.protocol.OFOpticalPortFeatures;
import java.util.Set;
import io.netty.buffer.ByteBuf;
import com.google.common.hash.PrimitiveSink;
import java.util.EnumSet;
import java.util.Collections;


public class OFOpticalPortFeaturesSerializerVer14 {

    public final static int RX_TUNE_VAL = 0x1;
    public final static int TX_TUNE_VAL = 0x2;
    public final static int TX_PWR_VAL = 0x4;
    public final static int USE_FREQ_VAL = 0x8;

    public static Set<OFOpticalPortFeatures> readFrom(ByteBuf bb) throws OFParseError {
        try {
            return ofWireValue(bb.readInt());
        } catch (IllegalArgumentException e) {
            throw new OFParseError(e);
        }
    }

    public static void writeTo(ByteBuf bb, Set<OFOpticalPortFeatures> set) {
        bb.writeInt(toWireValue(set));
    }

    public static void putTo(Set<OFOpticalPortFeatures> set, PrimitiveSink sink) {
        sink.putInt(toWireValue(set));
    }


    public static Set<OFOpticalPortFeatures> ofWireValue(int val) {
        EnumSet<OFOpticalPortFeatures> set = EnumSet.noneOf(OFOpticalPortFeatures.class);

        if((val & RX_TUNE_VAL) != 0)
            set.add(OFOpticalPortFeatures.RX_TUNE);
        if((val & TX_TUNE_VAL) != 0)
            set.add(OFOpticalPortFeatures.TX_TUNE);
        if((val & TX_PWR_VAL) != 0)
            set.add(OFOpticalPortFeatures.TX_PWR);
        if((val & USE_FREQ_VAL) != 0)
            set.add(OFOpticalPortFeatures.USE_FREQ);
        return Collections.unmodifiableSet(set);
    }

    public static int toWireValue(Set<OFOpticalPortFeatures> set) {
        int wireValue = 0;

        for(OFOpticalPortFeatures e: set) {
            switch(e) {
                case RX_TUNE:
                    wireValue |= RX_TUNE_VAL;
                    break;
                case TX_TUNE:
                    wireValue |= TX_TUNE_VAL;
                    break;
                case TX_PWR:
                    wireValue |= TX_PWR_VAL;
                    break;
                case USE_FREQ:
                    wireValue |= USE_FREQ_VAL;
                    break;
                default:
                    throw new IllegalArgumentException("Illegal enum value for type OFOpticalPortFeatures in version 1.4: " + e);
            }
        }
        return wireValue;
    }

}
