// Copyright (c) 2008 The Board of Trustees of The Leland Stanford Junior University
// Copyright (c) 2011, 2012 Open Networking Foundation
// Copyright (c) 2012, 2013 Big Switch Networks, Inc.
// This library was generated by the LoxiGen Compiler.
// See the file LICENSE.txt which should have been included in the source distribution

// Automatically generated by LOXI from template const_serializer.java
// Do not modify

package org.projectfloodlight.openflow.protocol.ver14;

import org.projectfloodlight.openflow.protocol.*;
import org.projectfloodlight.openflow.protocol.action.*;
import org.projectfloodlight.openflow.protocol.actionid.*;
import org.projectfloodlight.openflow.protocol.bsntlv.*;
import org.projectfloodlight.openflow.protocol.errormsg.*;
import org.projectfloodlight.openflow.protocol.meterband.*;
import org.projectfloodlight.openflow.protocol.instruction.*;
import org.projectfloodlight.openflow.protocol.instructionid.*;
import org.projectfloodlight.openflow.protocol.match.*;
import org.projectfloodlight.openflow.protocol.oxm.*;
import org.projectfloodlight.openflow.protocol.queueprop.*;
import org.projectfloodlight.openflow.types.*;
import org.projectfloodlight.openflow.util.*;
import org.projectfloodlight.openflow.exceptions.*;
import org.projectfloodlight.openflow.protocol.OFPortStatsPropType;
import io.netty.buffer.ByteBuf;
import com.google.common.hash.PrimitiveSink;

public class OFPortStatsPropTypeSerializerVer14 {

    public final static short ETHERNET_VAL = (short) 0x0;
    public final static short OPTICAL_VAL = (short) 0x1;
    public final static short EXPERIMENTER_VAL = (short) 0xffff;

    public static OFPortStatsPropType readFrom(ByteBuf bb) throws OFParseError {
        try {
            return ofWireValue(bb.readShort());
        } catch (IllegalArgumentException e) {
            throw new OFParseError(e);
        }
    }

    public static void writeTo(ByteBuf bb, OFPortStatsPropType e) {
        bb.writeShort(toWireValue(e));
    }

    public static void putTo(OFPortStatsPropType e, PrimitiveSink sink) {
        sink.putShort(toWireValue(e));
    }

    public static OFPortStatsPropType ofWireValue(short val) {
        switch(val) {
            case ETHERNET_VAL:
                return OFPortStatsPropType.ETHERNET;
            case OPTICAL_VAL:
                return OFPortStatsPropType.OPTICAL;
            case EXPERIMENTER_VAL:
                return OFPortStatsPropType.EXPERIMENTER;
            default:
                throw new IllegalArgumentException("Illegal wire value for type OFPortStatsPropType in version 1.4: " + val);
        }
    }


    public static short toWireValue(OFPortStatsPropType e) {
        switch(e) {
            case ETHERNET:
                return ETHERNET_VAL;
            case OPTICAL:
                return OPTICAL_VAL;
            case EXPERIMENTER:
                return EXPERIMENTER_VAL;
            default:
                throw new IllegalArgumentException("Illegal enum value for type OFPortStatsPropType in version 1.4: " + e);
        }
    }

}
