// Copyright (c) 2008 The Board of Trustees of The Leland Stanford Junior University
// Copyright (c) 2011, 2012 Open Networking Foundation
// Copyright (c) 2012, 2013 Big Switch Networks, Inc.
// This library was generated by the LoxiGen Compiler.
// See the file LICENSE.txt which should have been included in the source distribution

// Automatically generated by LOXI from template const_set_serializer.java
// Do not modify

package org.projectfloodlight.openflow.protocol.ver14;

import org.projectfloodlight.openflow.protocol.*;
import org.projectfloodlight.openflow.protocol.action.*;
import org.projectfloodlight.openflow.protocol.actionid.*;
import org.projectfloodlight.openflow.protocol.bsntlv.*;
import org.projectfloodlight.openflow.protocol.errormsg.*;
import org.projectfloodlight.openflow.protocol.meterband.*;
import org.projectfloodlight.openflow.protocol.instruction.*;
import org.projectfloodlight.openflow.protocol.instructionid.*;
import org.projectfloodlight.openflow.protocol.match.*;
import org.projectfloodlight.openflow.protocol.oxm.*;
import org.projectfloodlight.openflow.protocol.queueprop.*;
import org.projectfloodlight.openflow.types.*;
import org.projectfloodlight.openflow.util.*;
import org.projectfloodlight.openflow.exceptions.*;
import org.projectfloodlight.openflow.protocol.OFTableConfig;
import java.util.Set;
import io.netty.buffer.ByteBuf;
import com.google.common.hash.PrimitiveSink;
import java.util.EnumSet;
import java.util.Collections;


public class OFTableConfigSerializerVer14 {

    public final static int DEPRECATED_MASK_VAL = 0x3;
    public final static int EVICTION_VAL = 0x4;
    public final static int VACANCY_EVENTS_VAL = 0x8;

    public static Set<OFTableConfig> readFrom(ByteBuf bb) throws OFParseError {
        try {
            return ofWireValue(bb.readInt());
        } catch (IllegalArgumentException e) {
            throw new OFParseError(e);
        }
    }

    public static void writeTo(ByteBuf bb, Set<OFTableConfig> set) {
        bb.writeInt(toWireValue(set));
    }

    public static void putTo(Set<OFTableConfig> set, PrimitiveSink sink) {
        sink.putInt(toWireValue(set));
    }


    public static Set<OFTableConfig> ofWireValue(int val) {
        EnumSet<OFTableConfig> set = EnumSet.noneOf(OFTableConfig.class);

        if((val & DEPRECATED_MASK_VAL) != 0)
            set.add(OFTableConfig.DEPRECATED_MASK);
        if((val & EVICTION_VAL) != 0)
            set.add(OFTableConfig.EVICTION);
        if((val & VACANCY_EVENTS_VAL) != 0)
            set.add(OFTableConfig.VACANCY_EVENTS);
        return Collections.unmodifiableSet(set);
    }

    public static int toWireValue(Set<OFTableConfig> set) {
        int wireValue = 0;

        for(OFTableConfig e: set) {
            switch(e) {
                case DEPRECATED_MASK:
                    wireValue |= DEPRECATED_MASK_VAL;
                    break;
                case EVICTION:
                    wireValue |= EVICTION_VAL;
                    break;
                case VACANCY_EVENTS:
                    wireValue |= VACANCY_EVENTS_VAL;
                    break;
                default:
                    throw new IllegalArgumentException("Illegal enum value for type OFTableConfig in version 1.4: " + e);
            }
        }
        return wireValue;
    }

}
